	data	1024
	bra.s	start
base:	dc.b	0	;for SQBoard (see TCopy_install_bas)
	dc.b	12	; "   "   "
	dc.b	63	; "   "   "
	dc.b	192	; "   "   "
	dc.w	$4afb
	dc.w	ne-ns
ns:	dc.b	'SEC-COPY'
ne:
	even
select:	dc.b	0	; "   "   "
	dc.b	12	; "   "   "
	dc.b	63	; "   "   "
	dc.b	196	; "   "   "
cont:	dc.b	1	; "   "   "
	dc.b	0
start:	moveq	#0,d0
	trap	#1		;current Job
	tst.w	d1
	bne.s	anfang
	move.w	$110,a0		;install new procedure
	lea	defs,a1
	jsr	(a0)
	rts
defs:	dc.w	1
	dc.w	anfang-*
	dc.b	5,'TCOPY'
	dc.w	0,0,0
anfang:	lea	stack,a0
	move.l	a6,-(a7)
	move.l	a7,(a0)
	moveq	#$18,d0	 	;speicher fuer sec0
	move.l	#14000,d1	;und postabelle reservieren
	moveq	#-1,d2
	trap	#1
	tst.w	d0
	bne     exit2
	move.l	a0,a5
	lea	con1,a0		;fenster oeffnen	
	bsr	open
	bne	exit
	lea	cid1,a1         ;id sichern
	move.l	a0,(a1)
	moveq	#$27,d0		;set paper
	moveq	#24,d1
	moveq	#-1,d3
	trap	#3
	moveq	#$29,d0		;set ink
	moveq	#7,d1
	moveq	#-1,d3
	trap	#3
	moveq	#$20,d0		;clear
        moveq	#-1,d3
	trap	#3
	moveq	#$17,d0		;position text
	moveq	#56,d1
	moveq	#3,d2
	moveq	#-1,d3
	trap	#3
	lea	ctext,a1	;copyright
	move.w	$d0,a2
	jsr	(a2)
	lea	con2,a0		;fenster oeffnen	
	bsr	open
	bne	exit
	lea	cid,a1          ;id sichern
	move.l	a0,(a1)
	moveq	#$27,d0		;set paper
	moveq	#0,d1
	moveq	#-1,d3
	trap	#3
	moveq	#$29,d0		;set ink
	moveq	#7,d1
	moveq	#-1,d3
	trap	#3
	moveq	#$0e,d0		;enable cursor
	moveq	#-1,d3
	trap	#3
mloop:	bsr	menue		;menue ausgeben
mloop1:	lea	dsss,a1		;normale kopie
	clr.w	(a1)
	moveq	#1,d0		;fetch Byte
	moveq	#-1,d3
	trap	#3
	cmp.b	#232,d1		;F1
	beq	csource
	cmp.b	#236,d1		;F2
	beq	cdesti
	cmp.b	#240,d1		;F3
	beq	format
	cmp.b	#244,d1		;F4
	beq	backup
	cmp.b	#248,d1		;F5
	beq	sbackup
	cmp.b	#234,d1		;F6
	beq	tbackup
	cmp.b	#27,d1		;ESC
	bne.s	mloop1
exit:   lea	byet,a1		;verabschiedung
	bsr	tout
	moveq	#$f,d0
	moveq	#-1,d3
	trap	#3
	moveq	#$19,d0
	move.l	a5,a0
	trap	#1
exit0:	move.l	cid,d0
	beq.s	exit1
	move.l	d0,a0
	moveq	#2,d0		;close channel
	trap	#2
exit1:  move.l	cid1,d0
	beq.s	exit2
	move.l	d0,a0
	moveq	#2,d0		;close channel
	trap	#2
exit2:	move.l	(a7)+,a6	;a6 wiederherstellen
	moveq	#5,d0		;remove this Job
	moveq	#-1,d1
	trap	#1	
	moveq	#0,d0		;for basic
	rts

*aendere source
csource:lea	ss+3,a0
	eor.b	#3,(a0)
	lea	mts+3,a0
	eor.b	#3,(a0)
	bra	mloop

*aendere destination
cdesti:	lea	ds+3,a0
	eor.b	#3,(a0)
	lea	mtd+3,a0
	eor.b	#3,(a0)
	lea	ftm+3,a0
        eor.b	#3,(a0)
	lea	formt+5,a0
	eor.b	#3,(a0)
	bra	mloop

*destination formatieren
format: lea	ftext,a1
	bsr	tout
forl:	moveq	#1,d0		;fetch byte
	moveq	#-1,d3
	trap	#3
	bclr	#5,d1
	cmp.b	#'N',d1		;nein
	beq	mloop
	cmp.b	#'Y',d1
	bne.s	forl
	moveq	#3,d0		;format medium
	lea	formt,a0
	trap	#2
	bsr	error
	bra	mloop

* turbobackup
tbackup:move.l	ss,d0		;source
	move.l	ds,d1		;destination
	cmp.l	d0,d1
	beq	npos		;source=destination
        lea	tbackt,a1
	bsr	tout
	moveq	#1,d0		;zeichen holen
	moveq	#-1,d3
	trap	#3
	cmp.b	#27,d1
	beq	clall
	lea	vtext,a1
	bsr	tout
	lea	verify,a1
	clr.w	(a1)
tback0:	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bclr	#5,d1
	cmp.b	#'N',d1
	beq.s	tback1
	cmp.b	#'Y',d1
	bne.s	tback0
	lea	verify,a1
	not.b	(a1)	
tback1:	moveq	#6,d0		;freier speicher
	trap	#1
	tst.w	d0
	bne	clall
	moveq	#$18,d0  	;reichlich reservieren
	move.l	#400000,d1
	moveq	#-1,d2		;this job
	trap	#1
	tst.w	d0
	bne	clall
	lea	free,a1
	move.l	a0,(a1)
	lea	time1,a0
	move.l	$18000,(a0)
	trap	#0
	move.w	#$2700,sr
*base of 1770
	move.l	base,a4
	lea	3(a4),a3
* parameter holen
	lea	s1t,a1
	bsr	tout
	moveq	#0,d1		;side 0
	bsr	selects
	bsr	restore
* sector 0 holen
	move.b	cont,d0
	bne.s	cont0
	lea	1(a4),a2	;secregister
	bra.s	cont1
cont0:	lea	2(a4),a2	;secregister
cont1:	move.b	#1,(a2)		;sector 1
	move.b	#%10001010,(a4) ;read sector
	bsr	waiton
	move.l	a5,a0
	move.w	#511,d1
tbl0:	moveq	#3,d0
	and.b	(a4),d0		;status
	beq	etbackup	;fehler
	subq.b	#2,d0
	blt.s	tbl0
	move.b	(a3),(a0)+	;get data
        dbra	d1,tbl0
	move.b	#%11010000,(a4)	;force interrupt
	bsr	waitoff
*side 0 kopieren
	cmp.w	#9,$1a(a5)
	beq.s	tbl1
	moveq	#-19,d0
	bra	etbacku1
tbl1:	move.w	$1e(a5),d7	;sector pro disk
	bsr	rside1
	lea	ss1tr,a1
	bsr	tout
	moveq	#0,d1
	bsr	selectd
	bsr	restore
	move.w	$1e(a5),d7
	bsr	wside1
	move.w	$1c(a5),d0	;sectore pro track
	cmp.w	#9,d0		;ss
        beq.s	etbok
*side 1 kopieren
	lea	s2t,a1
	bsr	tout
	moveq	#1,d1
	bsr	selects
	move.w	$1e(a5),d7
	bsr	rside2
	lea	ss2tr,a1
	bsr	tout
	moveq	#1,d1
	bsr	selectd
	move.w	$1e(a5),d7
	bsr	wside2
*alles in ordnung
etbok:	move.w	#0,sr
	lea	time2,a0
	move.l	$18000,(a0)
	moveq	#0,d1
	bsr	selects		;source auf 0
	bsr	restore
	moveq	#0,d1
	bsr	selectd		;destination auf 0
	bsr	restore
	bsr	dselect
	moveq	#0,d0
	bsr	einfo
	bra	clall


* fehler bei turbobackup
etbackup:move.w	#0,sr
	bsr	waitoff
	bsr	dselect		;laufwerke aus
	moveq	#-1,d0
        bra     clall
etbacku1:move.w	#0,sr
	bsr	waitoff
	bsr	dselect		;laufwerke aus
	moveq	#-19,d0
        bra     clall
		
*eine seite lesen step in
rside1:	move.l	free,a0
	subq.w	#1,d7
	bsr	rtrack		;1.track
	subq.w	#1,d7
rsl1:	bsr	sin
	bsr	rtrack
	dbra	d7,rsl1
	rts

*eine seite schreiben step in
wside1:	move.l	free,a0
	subq.w	#1,d7
	bsr	wtrack		;1.track
	subq.w	#1,d7
wsl1:	bsr	sin
	bsr	wtrack
	dbra	d7,wsl1
	rts

*eine seite lesen step out
rside2:	move.l	free,a0
	subq.w	#1,d7
	bsr	rtrack		;1.track
	subq.w	#1,d7
rsl2:	bsr	sout
	bsr	rtrack
	dbra	d7,rsl2
	rts

*eine seite schreiben step out
wside2:	move.w	$1e(a5),d0
	subq.w	#1,d0
	move.b	cont,d1
	bne.s	wsl00
	move.b	d0,2(a4)
	bra.s	wsl10
wsl00:	move.b	d0,1(a4)
wsl10:	move.l	free,a0
	subq.w	#1,d7
	bsr	wtrack		;1.track
	subq.w	#1,d7
wsl2:	bsr	sout
	bsr	wtrack
	dbra	d7,wsl2
	rts

*ein track lesen
rtrack:	bsr	trout
	moveq	#2,d4		;3 versuche
rtl0:	move.l	a0,a1
	move.b	#1,(a2)		;ab ersten sector
	move.w	#4607,d6	;4608 byte pro track
	move.b	#%10011000,(a4)	;read msec
	bsr	waiton
rtl1:	moveq	#3,d0
	and.b	(a4),d0
	beq	ertl
	subq.b	#2,d0
	blt.s	rtl1
	move.b	(a3),(a1)+
	dbra	d6,rtl1
	move.b	(a4),d2
	move.b	#%11010000,(a4)	;force interrupt
	bsr	waitoff
	and.b	#28,d2
	bne.s	ertl
	move.l	a1,a0
	rts
ertl:	move.b	#%11010000,(a4)
	bsr	waitoff
	dbra	d4,rtl0
	bra	etbackup

*ein track schreiben
wtrack:	bsr	trout
	moveq	#2,d4
wtl0:	move.l	a0,a1
	move.b	#1,(a2)		;ab ersten sector
	move.w	#4607,d6	;4608 byte pro track
	move.b	#%10111010,(a4)	;write msec
	bsr	waiton
wtl1:	moveq	#3,d0
	and.b	(a4),d0
	beq.s	ewtl
	subq.b	#2,d0
	blt.s	wtl1
	move.b	(a1)+,(a3)
	dbra	d6,wtl1
	moveq	#10,d0
wtl2:	dbra	d0,wtl2
	move.b	#%11010000,(a4)
	bsr	waitoff
*verify track
	move.b	verify,d0
	beq.s	evtl1
	move.l	a0,a1
	move.b	#1,(a2)		;ab ersten sector
	move.w	#4607,d6	;4608 byte pro track
	move.b	#%10011000,(a4)	;read msec
	bsr	waiton
vtl1:	moveq	#3,d0
	and.b	(a4),d0
	beq	ewtl
	subq.b	#2,d0
	blt.s	vtl1
	move.b	(a3),d0
	cmp.b	(a1)+,d0
	dbra	d6,vtl1
	move.b	#%11010000,(a4)	;force interrupt
        bsr	waitoff
evtl1:	move.l	a1,a0
	rts
ewtl:	move.b	#%11010000,(a4)
	bsr	waitoff
	dbra	d4,wtl0
	bra	etbackup

* tracknummer ausgeben
trout:	movem.l	a0-a4,-(a7)
	move.l	cid,a0
	moveq	#$11,d0
	moveq	#25,d1
	moveq	#-1,d3
	trap	#3
	moveq	#5,d0
	moveq	#80,d1
	sub.w	d7,d1
	divu	#10,d1
	add.b	#'0',d1
	moveq	#-1,d3
	trap	#3
	moveq	#5,d0
	moveq	#80,d1
	sub.w	d7,d1
	divu	#10,d1
	swap	d1
	add.b	#'0',d1
	moveq	#-1,d3
	trap	#3
	movem.l	(a7)+,a0-a4
	rts

* spezielles backup
sbackup:lea	dsss,a1		;flag setzen
	not.w	(a1)
* eigentliche Backuproutine
backup:	move.l	ss,d0		;quelle=Ziel ?
	move.l	ds,d1
	cmp.l	d0,d1
	beq	oned            ;Ja
* zwei laufwerke
	lea	destit,a1	;Ziel einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	cmp.b	#27,d1		;esc
	beq	mloop
	lea	desti,a0	;destination oeffnen
	bsr	open
	bne	clall
	lea	did,a1
	move.l	a0,(a1)	
	lea	sourcet,a1	;Quelle einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	cmp.b	#27,d1		;esc
	beq	clall
	lea	source,a0	;source oeffnen
	bsr	open
	bne	clall
	lea	sid,a1
	move.l	a0,(a1)
* fat lesen source
	move.l	a5,a1  		;block 0 lesen
	moveq	#1,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#4,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#7,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	cmp.w	#10,$1a(a5)
	beq.s	backup0
	cmp.w	#3,$20(a5)
	beq.s	backup1
backup0:moveq	#-19,d0
	bra	clall
backup1:move.l	$28(a5),d0
	and.l	#$FFFFFF00,d0
	cmp.l	#$00030600,d0
	bne.s	backup0
	moveq	#6,d0		;freier speicher
	trap	#1
	tst.w	d0
	bne	clall
	moveq	#-3,d0
	sub.l	#4096,d1
	bmi	clall
	cmp.l	#24*1536,d1
	blt 	clall
	moveq	#$18,d0  	;reichlich reservieren
	moveq	#-1,d2		;this job
	trap	#1
	tst.w	d0
	bne	clall
	lea	free,a1		;adresse freier speicher
	move.l	a0,(a1)
	lea	bloecke,a0	;anzahl der sectoren
	moveq	#9,d0
	lsr.l	d0,d1		;max. platz sectoren
	subq.w	#1,d1
	move.w	d1,(a0)
	lea	96(a5),a0       ;file allocation table
	lea	1536(a5),a1     ;start der pos-tabelle
	move.w	$1c(a5),d0
	cmp.w	#9,d0		; SS ?
	bne.s	dsl 		; nein
	bsr	stab
	bra.s	copyd
dsl:	bsr	dtab		; DS
copyd:	bsr	sinfo		;startinfo ausgeben
	move.w	dsss,d0		;speziell ?
	beq	copyd1
* fat lesen destination
	move.l	did,a0		;destination id
	move.l	a5,a1  		;block 0 lesen
	moveq	#1,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#4,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#7,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	cmp.w	#10,$1a(a5)
	beq	backup0
	cmp.w	#3,$20(a5)
	bne	backup0
	move.l	$28(a5),d0
	and.l	#$FFFFFF00,d0
	cmp.l	#$00030600,d0
	bne	backup0
	lea	96(a5),a0		;start fat
        move.w	#479,d0
sl1:	move.b	#$FD,(a0)+		;alle bloecke frei
	move.b	#$00,(a0)+
	move.b	#$00,(a0)+
	dbra	d0,sl1
	lea	96(a5),a0		;start fat
	move.w	block1,d0		;anzahl belegte bloecke
	subq.w	#1,d0
sl2:	clr.b	(a0)			;block belegt
	addq.l	#3,a0
	dbra	d0,sl2
	move.w	$16(a5),d0	;good sectors
 	ext.l	d0
	divu	#3,d0
	sub.w	block1,d0	;anzahl der belegten bloecke abziehen
	bmi	omaus
	mulu	#3,d0		;free sector anpassen
	move.w	d0,$14(a5)
	lea	96(a5),a0       ;file allocation table
	lea	7296(a5),a1     ;start der 2. pos-tabelle
	move.w	$1c(a5),d0
	cmp.w	#9,d0		; SS ?
	bne.s	dsls 		; nein
	bsr	stab
	bra.s	copyss
dsls:	bsr	dtab		; DS
copyss:	lea	7296(a5),a6	;start 2. tabelle
copyd1:	lea	1536(a5),a4	;start tabelle
copydl:	bsr	sload		;sectoren lesen
        bpl.s	ecopydl
	move.w	dsss,d0		;speziell ?
	beq.s	copydl1
	lea	mean,a0         ;pos pointer anpassen
	move.l	(a0),a4
	exg	a4,a6
	move.l	a4,(a0)
copydl1:bsr	swrite1		;sectoren schreiben
	move.w	dsss,d0         ;speziell
	beq.s	copydl
	lea	mean,a0         ;pos pointer anpassen
	move.l	(a0),a4
	exg	a4,a6
        move.l	a4,(a0)
	bra.s	copydl
ecopydl:move.w	dsss,d0		;speziell
	beq	ecopyd
	lea	mean,a0
	move.l	a6,(a0)
	bsr	swrite2
* fat lesen source
	move.l	sid,a0		;sourceid
	lea	1536(a5),a1	;block 0 lesen
	moveq	#1,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#4,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#7,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
        lea	96(a5),a0	;start destination tabelle
	lea	1632(a5),a1	;start sourcetabelle
	move.w	#479,d0		;max 480 bloecke
sl3:	move.b	(a1),d1		;1.byte vom block
	cmp.b	#$fd,d1		;freier block ?
	beq.s	esl3
	move.b	d1,(a0)+	;blockzuordnung kopieren
	move.b	1(a1),(a0)+
	move.b	2(a1),(a0)+
esl3:	addq.l	#3,a1		;3 byte pro block
	dbra	d0,sl3
	move.l	1570(a5),34(a5) ;eof dir kopieren
* fat schreiben destination
	move.l	did,a0		;sourceid
	move.l	a5,a1		;block 0 schreiben
	moveq	#1,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	sblock
	bne	clall
	moveq	#4,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	sblock
	bne	clall
	moveq	#7,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	sblock
	bne	clall
	bra.s	ecopyds
ecopyd:	bsr	swrite2
ecopyds:lea	time2,a0	;endzeit
	move.l	$18000,(a0)
	bsr	einfo
	moveq	#0,d0
	move.w	dsss,d1		;speziell
	bne	clall
	move.w	bloecke,d2	;platz fuer bloecke
	move.w	block1,d1	;belegte bloecke
        mulu	#3,d1
	moveq	#0,d0
	cmp.w	d2,d1
	bhi	clall
	lea	copy2,a1
	bsr	tout
copy22: moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bclr	#5,d1
	cmp.b	#'N',d1
	beq	clall
	cmp.b	#'Y',d1
	bne.s	copy22
	move.w	block1,d7
	bsr	sinfo
	bra	ecopydl

* ein laufwerke
oned:	move.w	dsss,d0		;speziell ?
	bne	npos
	lea	sourcet,a1	;Quelle einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	cmp.b	#27,d1		;esc
	beq	mloop
	lea	source,a0	;Quell oeffnen
	bsr	open
	bsr	error
	bne	mloop
	lea	did,a1
	move.l	a0,(a1)
	lea	sid,a1
	move.l	a0,(a1)	
* fat lesen
oned1:	move.l	a5,a1  		;block 0 lesen
	moveq	#1,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#4,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
	moveq	#7,d1
	lea	mean1,a2
	move.l	a1,(a2)
	bsr	rblock
	bne	clall
        cmp.w	#3,$20(a5)
	beq.s	oned2
	moveq	#-19,d0
	bra	clall
oned2:	move.l	$28(a5),d0
	and.l	#$FFFFFF00,d0
	cmp.l	#$00030600,d0
	beq.s	oned3
	moveq	#-19,d0
	bra	clall
oned3:	moveq	#6,d0		;freier speicher
	trap	#1
	tst.w	d0
	bne	clall
	moveq	#-3,d0
	sub.l	#4096,d1
	bmi	clall
ok0:	cmp.l	#24*1536,d1
	blt	clall
ok1:	moveq	#$18,d0  	;reichlich reservieren
	moveq	#-1,d2          ;this job
	trap	#1
	tst.w	d0
	bne	clall
	lea	free,a1		;adresse freier speicher
	move.l	a0,(a1)
	lea	bloecke,a0	;anzahl der sectoren
	moveq	#9,d0
	lsr.l	d0,d1		;max. platz sectoren
	subq.w	#1,d1
	move.w	d1,(a0)
	lea	96(a5),a0      	;file allocation table
	lea	1536(a5),a1     ;start der pos-tabelle
	move.w	$1c(a5),d0
	cmp.w	#9,d0		; SS ?
	bne.s	ssl 		; nein
	bsr	stab
	bra.s	copys
ssl:	bsr	dtab		; DS
copys:	bsr	sinfo		;startinfo ausgeben
	lea	1536(a5),a4	;tabelle der positionen
copysl:	bsr	sload		;sectoren lesen
        bpl.s	ecopysl
	lea	destit,a1	;Quelle einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bsr	swrite1		;sectoren schreiben
	lea	sourcet,a1	;Quelle einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bra.s	copysl
ecopysl:lea	destit,a1	;Destination einlegen
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	cmp.b	#27,d1
	beq	clall
	bsr	swrite2
	lea	time2,a0	;endzeit
	move.l	$18000,(a0)
	bsr	einfo
	move.w	bloecke,d2	;platz fuer bloecke
	move.w	block1,d1	;belegte bloecke
	mulu	#3,d1
	moveq	#0,d0
	cmp.w	d2,d1
	bhi	clall
	lea	copy2,a1
	bsr	tout
copy21: moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bclr	#5,d1
	cmp.b	#'N',d1
	beq	clall
	cmp.b	#'Y',d1
	bne.s	copy21
	move.w	block1,d7
	bsr	sinfo
	bra.s	ecopysl

* nicht genug platz
omaus:	lea	omt,a1
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bra	clall

* nicht mit einem laufwerk
npos:	lea	npost,a1
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	trap	#3
	bra	clall

* sectoren laden
sload:	move.l	sid,a0		;sourceid
	lea	mean,a3		;tabellenposition speichern
	move.l	a4,(a3)
	move.w	bloecke,d7	;max. bloecke
	move.l	free,a1		;speicher fuer bloecke
slloop:	move.l	(a4),d1		;position
	bmi	eslloop		;ende
	lea	mean1,a2	;speicherpos merken fuer fehler
	move.l	a1,(a2)
	moveq	#2,d6		;3 versuche
e0:	bsr	rblock		;block lesen
	beq	e1
	lea	reade,a2	;1 lesefehler mehr
	addq.w	#1,(a2)
	move.l	mean1,a1	;speicherpos holen
	move.l	(a4),d1         ;pos
	dbra	d6,e0
	bra	clall
e1:	addq.l	#4,a4
	dbra	d7,slloop	;naechster block
eslloop:move.w	dsss,d0
	beq.s	e2
	lea	mean,a0
	move.l	a4,(a0)
e2:	tst.w	d7
	rts

* sectoren schreiben anzahl D7
swrite1:move.l	did,a0		;destinationid
	move.w	bloecke,d7      ;max. bloecke
	move.l	mean,a4         ;tabelle der positionen
	move.l	free,a1         ;speicher fuer bloecke
swloop1:move.l	(a4),d1		;position
	lea	mean1,a2	;speicherpos merken fuer fehler
	move.l	a1,(a2)
	moveq	#2,d6		;3 versuche
e3:	bsr	sblock		;block schreiben
	beq.s	e4
	lea	writee,a2	;1 schreibfehler mehr
	addq.w	#1,(a2)
	move.l	mean1,a1
	move.l	(a4),d1		;pos
	dbra	d6,e3
	bra	clall
e4:	addq.l	#4,a4
	dbra	d7,swloop1
	move.w	dsss,d0
        beq.s	e5
	lea	mean,a0
	move.l	a4,(a0)
e5:	rts

* sectoren schreiben
swrite2:move.l	did,a0		;destinationid
	move.l	mean,a4		;tabelle der positionen
	move.l	free,a1		;speicher fuer bloecke
swloop2:move.l	(a4),d1		;position
	bmi	eswl2
	lea	mean1,a2	;speicherpos merken fuer fehler
	move.l	a1,(a2)
	moveq	#2,d6		;3 versuche
e6:	bsr	sblock		;block schreiben
	beq.s	e7
	lea	writee,a2	;1 schreibfehler mehr
	addq.w	#1,(a2)
	move.l	mean1,a1
	move.l	(a4),d1
	dbra	d6,e6
	bra	clall
e7:	addq.l	#4,a4
	bra.s	swloop2
eswl2:	rts

* menue ausgeben
menue:	move.l	cid,a0
	moveq	#$20,d0		;clear
	moveq	#-1,d3
	trap	#3
	lea	mtext,a1	;menuetext ausgeben
	move.w	$d0,a2
	jsr	(a2)
	rts

* menue ausgeben
tout:	movem.l	a2-a4,-(a7)
	move.l	a1,-(a7)
	move.l	cid,a0
	moveq	#$20,d0		;clear
	moveq	#-1,d3
	trap	#3
	move.l	(a7)+,a1
	move.w	$d0,a2
	jsr	(a2)
	bsr	ton
	movem.l	(a7)+,a2-a4
        rts

*ton ausgeben
ton:	lea     click,a3
        moveq   #$11,d0
        trap    #1
	rts

click:  DC.W      $0A08,$0000
        DC.W      $AAAA,$1E1E
        DC.W      $000A,$000A
        DC.W      $0000,$0100
        even

* kanal oeffnen
open:	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#2
	tst.w	d0
	rts

* kanal schliessen
close:	moveq	#2,d0
	trap	#2
	tst.w	d0
	rts

* positionieren und lesen
rblock:	movem.l	a0/a4,-(a7)
	moveq	#-15,d0
	move.l	d1,d3			;parameter ueberpruefen
	cmp.b	#9,d3			;sector
	bhi.s	rbe
	lsr.l	#8,d3
	cmp.b	#1,d3			;side
	bhi.s	rbe
	lsr.l	#8,d3
	cmp.b	#79,d3			;tracks
	bhi.s	rbe
	moveq	#$42,d0
	moveq	#-1,d3
	trap	#3
	tst.w	d0
	bne.s	rbe
	moveq	#$3,d0
	move.w	#512,d2
	moveq	#-1,d3
	move.l	mean1,a1
	trap	#3
rbe:	movem.l	(a7)+,a0/a4
	tst.w	d0
	rts

* positionieren und schreiben

sblock:	movem.l	a0/a4,-(a7)
	moveq	#-15,d0
	move.l	d1,d3			;parameter ueberpruefen
	cmp.b	#9,d3			;sector
	bhi.s	sbe
	lsr.l	#8,d3
	cmp.b	#1,d3			;side
	bhi.s	sbe
	lsr.l	#8,d3
	cmp.b	#79,d3			;tracks
	bhi.s	sbe
	moveq	#$42,d0
	moveq	#-1,d3
	trap	#3
	tst.w	d0
	bne.s	sbe
	moveq	#$7,d0
	move.w	#512,d2
	moveq	#-1,d3
	move.l	mean1,a1
	trap	#3
sbe:	movem.l	(a7)+,a0/a4
	tst.w	d0
	rts

*Tabellenposition DS
dtab:	moveq	#0,d7		;keine belegten bloecke
	moveq	#0,d6		;kein block untersucht
	moveq	#0,d4
	move.w	$18(a5),d4	;total number of sectors
	divu	$20(a5),d4	;sectors pro block
dloop:	cmp.w	d4,d6		;letzter block ?
	beq	edloop1		;ja
	cmp.b	#$fd,(a0)	;leerer block ?
	beq	edloop0		;ja
	moveq	#0,d0
	move.w	d6,d0		;zuerst track
	divu	#6,d0		;track=nummer div 6
	move.w	d6,d1		;jetzt side
	and.w	#1,d1		;side=nummer mod 2
	move.w	$26(a5),d2	;trackoffset
	move.w	d0,d3		;track
	mulu	d3,d2		;track * trackoffset
	divu	#9,d2		;( track * trackoffset ) div 9
	swap	d2		;( track * trackoffset ) mod 9
	moveq	#0,d3
	move.w	d6,d3		;block
	divu	#6,d3		;block div 6
	swap	d3		;block mod 6
	lsr.w	#1,d3		;( block mod 6 ) div 2
	moveq	#0,d5		;pos
	move.b	d0,d5		;track*65536
	lsl.l	#8,d5
	move.b	d1,d5		;side*256
	lsl.l	#8,d5
	add.w	d3,d2		;1. drittel des blockes
	and.l	#$0000ffff,d2
	divu	#9,d2		;1. drittel div 9
	swap	d2		;1. drittel mod 9
	addq.w	#1,d2		;1. drittel mod 9 + 1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+	;1. position des blockes
	addq.w	#2,d2		;2. drittel 
	and.l	#$0000ffff,d2
	divu	#9,d2		;2. drittel div 9
	swap	d2		;2. drittel mod 9
	addq.w	#1,d2		;2. drittel mod 9 +1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+        ;2. position des blockes
	addq.w	#2,d2		;3. drittel 
	and.l	#$0000ffff,d2
	divu	#9,d2		;3. drittel div 9
	swap	d2		;3. drittel mod 9
	addq.w	#1,d2		;3. drittel mod 9 +1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+        ;3. position des blockes
	move.l	#-1,(a1)	;endemarker
	addq.w	#1,d7		;ein weiterer belegter block
edloop0:addq.l	#3,a0		;wegen 24 bit eintraegen
	addq.w	#1,d6		;naechste position
	bra	dloop		;untersuchen ob belegt
edloop1:lea	block1,a0
	move.w	d7,(a0)
	rts

* Tabellenposition SS
stab:	moveq	#0,d7		;keine belegten bloecke
	moveq	#0,d6		;kein block untersucht
	moveq	#0,d4
	move.w	$18(a5),d4	;total number of sectors
	divu	$20(a5),d4	;sectors pro block
sloop:	cmp.w	d4,d6		;letzter block ?
	beq	esloop1		;ja
	cmp.b	#$fd,(a0)	;leerer block ?
	beq	esloop0		;ja
	moveq	#0,d0
	move.w	d6,d0		;zuerst track
	divu	#3,d0		;track=nummer div 6
	move.w	$26(a5),d2	;trackoffset
	move.w	d0,d3		;track
	mulu	d3,d2		;track * trackoffset
	divu	#9,d2		;( track * trackoffset ) div 9
	swap	d2		;( track * trackoffset ) mod 9
	moveq	#0,d3
	move.w	d6,d3		;block
	divu	#3,d3		;block div 6
	swap	d3		;block mod 6
	moveq	#0,d5		;pos
	move.b	d0,d5		;track*65536
	lsl.l	#8,d5
	move.b	#0,d5		;side*256 side=0
	lsl.l	#8,d5
	add.w	d3,d2		;1. drittel des blockes
	and.l	#$0000ffff,d2
	divu	#9,d2		;1. drittel div 9
	swap	d2		;1. drittel mod 9
	addq.w	#1,d2		;1. drittel mod 9 + 1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+	;1. position des blockes
	addq.w	#2,d2		;2. drittel 
	and.l	#$0000ffff,d2
	divu	#9,d2		;2. drittel div 9
	swap	d2		;2. drittel mod 9
	addq.w	#1,d2		;2. drittel mod 9 +1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+        ;2. position des blockes
	addq.w	#2,d2		;3. drittel 
	and.l	#$0000ffff,d2
	divu	#9,d2		;3. drittel div 9
	swap	d2		;3. drittel mod 9
	addq.w	#1,d2		;3. drittel mod 9 +1
	move.b	d2,d5		;sector
	move.l	d5,(a1)+        ;3. position des blockes
	move.l	#-1,(a1)	;endemarker
	addq.w	#1,d7		;ein weiterer belegter block
esloop0:addq.l	#3,a0		;wegen 24 bit eintraegen
	addq.w	#1,d6		;naechste position
	bra	sloop		;untersuchen ob belegt
esloop1:lea	block1,a0
	move.w	d7,(a0)
	rts

* fehler ausgeben falls vorhanden
error:	tst.w	d0
	beq     eerror
	move.l	d0,-(a7)
	bsr	ton
	move.l	cid,a0		;clear
        moveq	#$20,d0
	moveq	#-1,d3
	trap	#3
	move.l	(a7),d0
	move.w	$cc,a1  	;fehlertext ausgeben
	jsr	(a1)
	moveq	#1,d0		;auf taste warten
	moveq	#-1,d3
	trap	#3
	move.l	(a7)+,d0
	tst.w	d0
eerror:	rts

* alle kanaele schliessen
clall:	bsr	error
	move.l	sid,d0		;source
	beq.s	cldesti
	move.l	d0,a0
	moveq	#2,d0
	trap	#2
cldesti:move.l	did,d0		;desti
	beq.s	clheap
	move.l	d0,a0
	moveq	#2,d0
	trap	#2
clheap:	move.l	free,d0		;reserved memory
	beq.s	clrts
	move.l	d0,a0
	moveq	#$19,d0
	trap	#1
clrts:	lea	sid,a0		;alle loeschen
	clr.l	(a0)
	lea	did,a0
	clr.l	(a0)
	lea	free,a0
	clr.l	(a0)
	lea	reade,a0
	clr.w	(a0)
	lea	writee,a0
	clr.w	(a0)
	move.l	stack,a7
	bra	mloop

*startinfo
sinfo:	lea	time1,a0	;startzeit
	move.l	$18000,(a0)
	moveq	#0,d0
	move.w	d7,d0		;belegte bloecke
	mulu	#3,d0		;drei sectoren pro block
	moveq	#3,d2
	lea	site,a1
	bsr	dez
	lea	sinfot,a1	;startinfo ausgeben
	bsr	tout
	rts

*endinfo
einfo:	move.l	time2,d0	;endzeit
	sub.l	time1,d0	;startzeit
	moveq	#2,d2
	lea	timesp,a1
	bsr	dez
	move.w	reade,d0 	;lesefehler anzeigen
	moveq	#2,d2
	lea	re,a1
	bsr	dez
	move.w	writee,d0 	;schreibfehler anzeigen
	moveq	#2,d2
	lea	we,a1
	bsr	dez
	move.w	reade,d0	;lesenfehler
	add.w	writee,d0	;schreibfehler
	beq.s	einfo1
	lea	einfot,a1	;startinfo ausgeben
	bsr	tout
	bra.s	einfo2
einfo1:	lea	bc,a1
	bsr	tout
einfo2:	move.l	cid,a0
	lea	einfot1,a1
	move.w	$d0,a2
	jsr	(a2)
	moveq	#1,d0		;auf taste warten
	moveq	#-1,d3
	trap	#3
	rts

* zahl in ascii 
dez     divu    #10,d0
        swap    d0
        add.b   #$30,d0
        move.b  d0,-(a1)
        clr.w   d0
        swap    d0
        dbra    d2,dez
        rts

* restore
restore:move.b	#%00001000,(a4)	;restore
	bsr	waiton
	bsr	waitoff
        rts

* select destination d0=laufwerk 0..3
*        d1=side 0,1
selectd:move.b	ds+3,d0		;source
	sub.b	#$30,d0		;nur wert
	bra.s	selecta

* select source d0=laufwerk 0..3
*        d1=side 0,1
selects:move.b	ss+3,d0		;source
	sub.b	#$30,d0		;nur wert

selecta:move.b	cont,d2
	beq.s	scst
	cmp.b	#1,d2
	beq.s	ssqb
	cmp.b	#2,d2
	beq.s	strump
	moveq	#-19,d0
	bra	clall
* select cst
scst:	moveq	#0,d2
	and.l	#$3,d0
	bset	d0,d2
	or.b	d1,d2
	bra.s	srts
* select sqb
ssqb:	moveq	#8,d2
	and.l	#3,d0
	bset	d0,d2
	or.b	d1,d2
	bra.s	srts
* select trump
strump:	lsl.b	#3,d1
	or.b	d0,d1
	eor.b	#7,d1
	move.b	d1,d2
srts:	move.l	select,a0
	move.b	d2,(a0)
	rts

* laufwerk abschalten
dselect:move.b	#%00000000,(a4)
	bsr	waiton
	move.b	#%11010000,(a4)		* force interrupt
dsel:	btst	#7,(a4)
	bne.s	dsel
	move.l	select,a0
	clr.b	(a0)
	rts

* auf ausfuehrung warten
waiton:	btst	#0,(a4)		;status
	beq.s	waiton
	rts

* auf ende ausfuehrung warten
waitoff:btst	#0,(a4)		;status
	bne.s	waitoff
	rts

* step in -> track 80
sin:	move.b	#%01010100,(a4)	;step in
	bsr	waiton
	bsr	waitoff
	rts

* step out -> track 0
sout:	move.b	#%01110100,(a4)	;step in
	bsr	waiton
	bsr	waitoff
	rts

free:	dc.l	0
mean:	ds.l	1
mean1:	ds.l	1

bloecke:ds.w	1
block1:	ds.w	1

source:	dc.w	se-ss
ss:	dc.b	'FLP1_*d2d'
se:	
	even

sid:	dc.l	0

desti:	dc.w	de-ds
ds:	dc.b	'FLP2_*d2d'
de:	
	even

did:	dc.l	0

con1:	dc.w	con1e-con1s
con1s:	dc.b	'con_384x40a64x1_16'
con1e:
	even

cid1:	ds.l	1

con2:	dc.w	con2e-con2s
con2s:	dc.b	'con_376x20a68x17_16'
con2e:
	even

cid:	ds.l	1

ctext:	dc.w	cte-cts                                             
cts:	dc.b	'Sectorcopy  Ralf Biedermann 12.89 Public Domain'
cte:
	even

mtext:	dc.w	mte-mtst
mtst:	dc.b	'F1=source F2=dest. F3=format dest. F4=backup <ESC>=quit',10
mts:	dc.b	'FLP1      '
mtd:	dc.b	'FLP2     F5=compr. backup  F6=Turbobackup '
mte:
	even

ftext:	dc.w	fte-fts
fts:	dc.b	'Format destination disk in drive '
ftm:	dc.b	'FLP2_ (Y/N)? ',10
fte:
	even

sourcet:dc.w	ste-sts                                          
sts:	dc.b	'insert source disk and press any key   <ESC>=stop '
ste:
	even

copy2:	dc.w	c2e-c2s                     
c2s:	dc.b	'All sectors completely stored in memory.',10
	dc.b	'Another copy? Y/N '
c2e:
	even

destit:	dc.w	dte-dts
dts:	dc.b	'insert destination disk and press a key   <ESC>=stop '
dte:
	even

byet:	dc.w	bte-bts                      
bts:	dc.b	'I hope it worked well. '
	dc.b	'Have a nice day and best wishes from',10
	dc.b	'RBsoft 89'
bte:
	even

sinfot:	dc.w	site-sits
sits:	dc.b	'Used sectors: 0000'
site:
	even

einfot:	dc.w	we-eits
eits:	dc.b	'Read error: 000'
re:	dc.b	'   Write error: 000'
we:	
	even
bc:	dc.w	bce-bcs                          
bcs:	dc.b	'Backup has successfully ended.'
bce:
	even

omt:	dc.w	omte-omts                               
omts:	dc.b	'Destination disk has not enough free sectors!',10
	dc.b	'Please press a key. '
omte:
	even

tbackt:	dc.w	tbte-tbts                                          
tbts:	dc.b	"Turbobackup will start now! Forget your cup of tea.",10
	dc.b	'Please press a key.  <ESC>=Return '
tbte:
	even

vtext:	dc.w	vte-vts
vts:	dc.b	'Verify Y/N '
vte:
	even

verify:	dc.w	0

npost:	dc.w	npose-nposs
nposs:	dc.b	'This option will need two'
	dc.b	' diskdrives - sorry.',10
	dc.b	'Press any key, please. '
npose:	
	even

einfot1:dc.w	eite-eits1
eits1:	dc.b	10,'elapsed time: 000'
timesp:	dc.b	' seconds. Press any key. '
eite:
	even

s1t: 	dc.w	es1t-ss1t 
ss1t:	dc.b	'Reading   side: 1 track:'
es1t:
	even

s2t: 	dc.w	es2t-ss2t
ss2t:	dc.b	'Reading   side: 2 track:'
es2t:
	even

ss1tr: 	dc.w	ses1t-sss1t
sss1t:	dc.b	'Writing   side: 1 track:'
ses1t:
	even

ss2tr: 	dc.w	ses2t-sss2t
sss2t:	dc.b	'Writing   side: 2 track:'
ses2t:
	even
 
stack:	ds.l	1
time1:	ds.l	1
time2:	ds.l	1
reade:	dc.w	0
writee:	dc.w	0
dsss:	dc.w	0

formt:	dc.w	5
	dc.b	'FLP2_'
	even

